assume cs:code,ds:data

data segment
x db 12h,16h,20h,27h,30h,32h
n equ 6h
key equ 32h
mesg db "Not found$"
data ends


code segment
start:
  mov ax,data
  mov ds,ax

  mov dl,key


  mov di,n-1  ;di is hi
  mov cx,0    ;cx is lo

  mov bp, offset x


  stloop:
  cmp di,cx   ;hi : lo
  jl notfound

   mov si,cx  
   add si,di  
   shr si,1   ;si = mid = (lo + hi)/2;

   mov al,[si+bp]
   cmp dl,al
   je found
   jl lower

   mov cx,si  ;low,mid
   add cx,1   ;
   jmp stloop

   lower:
   mov di,si ;high,mid
   sub di,1  ;
   jmp stloop

found:
mov dx,si
add dx,30h
mov ah,06
int 21h
jmp endprog


notfound:
mov dx, offset mesg
mov ah,09h
int 21h

endprog:
mov ah,4ch
int 21h
code ends
end start


